# -*- coding: UTF-8 -*-

import sys
try:
 	import pygtk
  	pygtk.require("2.0")
except:
  	pass
try:
	import gtk
  	import gtk.glade
except:
	sys.exit(1)

import os
import pango #Empleado para cambiar estilos de fuentes y atributos varios del interface
import Cfichero_festival

class Cgui_festival:

	def __init__(self):
		#Coloco el archivo del interface
		self.festival_dir = "/usr/share/cga-FestivalGui/"
		#self.festival_dir = ""
		self.gladefile = self.festival_dir + "festival.glade"
		self.wTree = gtk.glade.XML(self.gladefile) 
			
		#Creo un diccionario con los dististos eventos y funciones asociadas
		dic = { "on_cmp_txt_activate" : self.pulsa_introtxt,
				"on_bot_hablar_clicked" : self.bot_hablar,
				"on_tam_letra_change_value" : self.chg_tam,
				"on_tam_letra_value_changed": self.chg_tam,
				"on_window_main_destroy" : gtk.main_quit }
				
		#Paso el diccionario de funciones a mi arbol de Widget 
		self.wTree.signal_autoconnect(dic)
		
		#Obtengo todos los objetos para trabajar con ellos
		self.historicotxt = self.wTree.get_widget('list_txt')#lista superior de frases escritas
		self.scrolltxt = self.wTree.get_widget('scroll_txt')#scroll de la lista
		self.campotxt = self.wTree.get_widget('cmp_txt')#campo de texto donde se escriben las frases
		#self.vlect = self.wTree.get_widget('vel_lec')#escala para la velocidad
		self.v_voz = self.wTree.get_widget('v_voz')#grupo de botones de tipo de voz, por defecto el activo es el hombre
		self.tamletra = self.wTree.get_widget('tam_letra')#tamaño de letra

		#Coloco el Foco del arranque directamente en el campo de texto
		self.campotxt.grab_focus()
	
	#Funcion cambia tamaño de letra de los campos de texto
	def chg_tam(self,widget,data="None"):
		#self.campotxt.modify_text(gtk.STATE_NORMAL, gtk.gdk.color_parse("red"))#color 
		font = str(self.tamletra.get_value())#Genero la fuente tipo y tamaño a escribir en el interface
		self.campotxt.modify_font(pango.FontDescription(font))#Modifico la fuente del campo de texto
		self.historicotxt.modify_font(pango.FontDescription(font))#Modifico la fuente del historico

	#Funcion que se activa al pulsar el boton de Reproducir
	def bot_hablar(self,widget):

		#Recogemos variables

		#Tomamos la velocidad de la lectura
		#velocidad = self.vlect.get_value()

		#El tipo de voz elegida
		#compruebo si la voz por defecto (hombre) esta activo
		if(self.v_voz.get_active()):
			voz = "voice_JuntaDeAndalucia_es_pa_diphone"
		else:
			voz = "voice_JuntaDeAndalucia_es_sf_diphone"
		
		#Recogemos el valor del campo de texto
		texto = self.campotxt.get_text()
		
		# Si el valor no es vacio
		if texto != "":			
			#Lo escribimos en el fichero temporal y ejecutamos festival
			cfichero = Cfichero_festival.Cfichero_festival()
			#cfichero.edit_conf(voz,velocidad)#escribo en el fichero de configuracion
			cfichero.edit_conf(voz)#escribo en el fichero de configuracion
			cfichero.putfichero(texto)#escribo el texto a pronunciar
			cfichero.readfichero()#Ejecuto la frase a leer

			#Lo anadimos al historial - campo superior de texto
			self.put_txt_history(self.campotxt.get_text())

			#Volvemos a dejar el campo vacio
			self.campotxt.set_text("")


	#Funcion que se activa al pulsar INTRO en el campo de texto
	def pulsa_introtxt(self, widget,data="None"):
		self.bot_hablar(widget)
		
		
	#Introduce una linea mas en el historico de reproducciones
	#Campo de texto de la parte superior del Interface
	def put_txt_history(self, texto):
		#Generamos el Buffer del TextView (Contenido del textview)
		buffer_vt = self.historicotxt.get_buffer()	
		#Seteo dicho buffer y lo relaciono con el TextView
		self.historicotxt.set_buffer(buffer_vt)  
		#Posicion Inicial del contenido del buffer
		it1 = buffer_vt.get_start_iter()
		# Posicion Final del contenido del buffer
		it2 = buffer_vt.get_end_iter()
		#Obtengo el texto del buffer
		textoEnBufer = buffer_vt.get_text(it1, it2)
		#Lo completo con el texto enviado
		textoEnBufer +=  texto + '\n'
		# Inserto el texto en el TextBuffer y directamente se muestra
		buffer_vt.set_text(textoEnBufer)
		#Coloco el scroll correctamente al buffer insertado (para que se desplace solo hacia abajo)
		self.desplazar_scroll_final(buffer_vt, buffer_vt.get_end_iter())
	
	#Desplaza la vista del TextView para no perder de vista el texto
	def desplazar_scroll_final(self,id_buffer,posicion):
		endmark = id_buffer.create_mark(None, posicion)
		self.historicotxt.scroll_mark_onscreen(endmark)

